



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Theano3.2-练习之数据集及目标函数介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Theano3.2-练习之数据集及目标函数介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 00:20:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>来自http://deeplearning.net/tutorial/gettingstarted.html#gettingstarted</p>
<p><strong>一、下载</strong></p>
<p>在后续的每个学习算法上，都需要下载对应的文档，如果想要一次全部下好，那么可以复制git上面的这个教程的资料：</p>
<div>
<div>
<pre class="prettyprint linenums">git clone git://github.com/lisa-lab/DeepLearningTutorials.git</pre>
<div><br>
</div>
</div>
</div>
<div></div>
<p><strong>二、数据集</strong></p>
<p>MNIST 数据集(<a href="http://deeplearning.net/data/mnist/mnist.pkl.gz" rel="external nofollow noreferrer">mnist.pkl.gz</a>)（现在这个数据集除了教学，好像已经没什么人关注了）</p>
<p>这个<a href="http://yann.lecun.com/exdb/mnist" rel="external nofollow noreferrer">MNIST</a>&nbsp;数据集包含的是手写数字图像，其中有6w张训练样本和1w张测试样本，不过在几乎许多论文和本教程中，都是将这6w张训练样本划分成5w张训练样本和1w张验证集样本，所有的图片都已经中心化而且是固定的大小28×28，其中是灰度图，白色为255，黑色为0.为了方面本教程，是需要在python下使用的，可以下载&nbsp;<a href="http://deeplearning.net/data/mnist/mnist.pkl.gz" rel="external nofollow noreferrer">here</a>.也就是已经划分好了三个list：训练集、验证集和测试集。每一个list都是由图像和相应的标签组成的。其中图像是numpy的784（28*28）的一维数组（就是把2维的图像拉成一条向量），标签则是一个0-9之间的数字。下面的代码演示了如何使用这个数据集：</p>
<pre class="prettyprint linenums">import cPickle, gzip, numpy

# Load the dataset<br />
f = gzip.open(&#039;mnist.pkl.gz&#039;, &#039;rb&#039;)<br />
train_set, valid_set, test_set = cPickle.load(f)<br />
f.close()</pre>
<p>当使用这个数据集的时候，通常是将它划分成minibatches（&nbsp;<a href="http://deeplearning.net/tutorial/gettingstarted.html#opt-sgd" rel="external nofollow noreferrer"><em>Stochastic<br />
 Gradient Descent</em></a>）（还有http://blog.csdn.net/shouhuxianjian/article/details/41040245，这是hinton的视频的第6课）。我们建议你可以将这个数据集放入到共享变量（shared variables）中，并通过基于minibatch索引、给定一个固定和已知的batch size来访问它。这样做的好处就是共享变量之后可以用在gpu上，因为当将数据复制到GPU内存上的时候会有较大的开销，如果按照代码的执行（每个minibatch都是独立的）来进行传输数据的时候，如果不是用共享变量的方法，结果反而比只使用CPU的速度还慢。如果使用Theano<br />
 共享变量，那么就是让Theano将整个数据在共享变量构造的时候通过一个单一的调用都复制到GPU上。之后，GPU可以通过在这个共享变量上进行切片slice来访问任何minibatch，而不需要从cpu的内存上复制到GPU上，所以避免了很多的数据传输的开销。因为这些数据点和他们的标签通常都是不同的（标签通常是整数，而数据点通常是实数），我们建议使用不同的变量来表示数据和标签。同样我们推荐使用对这三个不同的集合也采用不同的变量来使得代码更具有可读性（会生成6个不同的共享变量）。因为当前的数据是一个变量，而且一个minibatch可以被定为这个变量的一个切片，所以很自然的可以通过指定索引和尺寸来定义一个minibatch。在我们的步骤中，batch<br />
 size在代码执行过程中&nbsp;一直是一个常量，所以一个函数实际上需要的只是索引来指定哪个数据点被使用了。下面的代码来表示如何存储数据并且如何访问一个minibatch：</p>
<pre class="prettyprint linenums">def shared_dataset(data_xy):<br />
    &quot;&quot;&quot; Function that loads the dataset into shared variables

    The reason we store our dataset in shared variables is to allow<br />
    Theano to copy it into the GPU memory (when code is run on GPU).<br />
    Since copying data into the GPU is slow, copying a minibatch everytime<br />
    is needed (the default behaviour if the data is not in a shared<br />
    variable) would lead to a large decrease in performance.<br />
    &quot;&quot;&quot;<br />
    data_x, data_y = data_xy<br />
    shared_x = theano.shared(numpy.asarray(data_x, dtype=theano.config.floatX))#因为GPU只接受float类型<br />
    shared_y = theano.shared(numpy.asarray(data_y, dtype=theano.config.floatX))#因为GPU只接受float类型<br />
    # When storing data on the GPU it has to be stored as floats<br />
    # therefore we will store the labels as ``floatX`` as well<br />
    # (``shared_y`` does exactly that). But during our computations<br />
    # we need them as ints (we use labels as index, and if they are<br />
    # floats it doesn&#039;t make sense) therefore instead of returning<br />
    # ``shared_y`` we will have to cast it to int. This little hack<br />
    # lets us get around this issue<br />
    return shared_x, T.cast(shared_y, &#039;int32&#039;) #返回的时候强制标签为int类型

test_set_x, test_set_y = shared_dataset(test_set)<br />
valid_set_x, valid_set_y = shared_dataset(valid_set)<br />
train_set_x, train_set_y = shared_dataset(train_set)

batch_size = 500    # size of the minibatch

# accessing the third minibatch of the training set 访问训练集的第三个minibatch

data  = train_set_x[2 * 500: 3 * 500]<br />
label = train_set_y[2 * 500: 3 * 500]</pre>
<p>在GPU上存储的数据只能是floats类型的，（存储在GPu上时，右边的dtype被赋&#20540;为theano.config.floatX）.为了绕过这个标签上的问题，通过将其存储为float，然后返回的时候强制为int类型。</p>
<p>note：如果你想要在GPU上运行代码，而你使用的数据集太大而无法放入GPU内存中，这种情况下，你可能会将数据存储到一个共享变量中。然而你可以存储一个足够小的数据块（几个minibatches）放到一个共享变量中，然后使用这个来进行训练，当这个数据块训练完成之后，更新存储的数据块换下一部分。这个方法是为了最小化CPU和GPU之间数据传输的次数的折衷方法。</p>
<p><strong>三、符号</strong></p>
<p><strong>&nbsp;数据集符号</strong></p>
<p>我们将数据集表示成<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150606094721846?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvc2hvdWh1eGlhbmppYW4=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center">，当需要区别对待的时候，将训练集，验证集和测试集表示成：:&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/4ed176fa7b8f2f50b96d46c3d01e1ec241575ca6.png">,&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/a58509a19258f2b7aa2354d3fd6529f50321da52.png">&nbsp;和<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/f6d0ab28f616a0a7aa1bfa2b005a07f5c8bcbfb6.png">。验证集是用来执行模型选取和超参数选择的，而且测试集是用来验证最后的<br />
 泛化误差和以无偏的方式来对比不同的算法。该教程基本上处理的是分类问题，这里每个数据集<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150606094721846?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvc2hvdWh1eGlhbmppYW4=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center">是有关&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/dd8ac449bcfbed8691b46ac75a241f1d4b2e5a40.png">对的索引集合，使用上标来区分不同的训练集样本：<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/f20742b986bc476d570774c823d3f1de7b31d1f0.png">&nbsp;是第<br />
 i 个维度为<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150606094721846?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvc2hvdWh1eGlhbmppYW4=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center">的训练样本。相&#20284;的，<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/861ccf187e0f8c031d5f43e218b71f7e8c6430ce.png">是第<br />
 i 个指派给输入<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ccb122c9db21d2f7e393bf3482a8a8339e8559e4.png">的标签。这样就可以简单的扩展这些例子，使得<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/05cd3501fa05972c2841eb937fa52ea68ebdd1ea.png">能够有其他类型（例如，高斯回归，或者能够预测多个符号的多项式组（也就是多分类））。</p>
<p><strong>数学约定</strong></p>
<ul><li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/10cb764f88509fb1c8012366993fdbee98f31bc5.png">: 大写符号用来表示一个矩阵，除非有其他的特指</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/224b256fe8e7ad35c4ca177e23f579354bb6f260.png">: 矩阵<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/10cb764f88509fb1c8012366993fdbee98f31bc5.png">的第i<br />
 行第j 列的元素</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/93bdd1a99dc7dd4697e45d515f50f9614ec1ccd2.png">: 向量, 表示矩阵<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/10cb764f88509fb1c8012366993fdbee98f31bc5.png">第i<br />
 行</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/9a592d673939e87b75e5335e76af0c822c7d4259.png">: 向量, 表示矩阵<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/10cb764f88509fb1c8012366993fdbee98f31bc5.png">第j<br />
 列</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/8136a7ef6a03334a7246df9097e5bcc31ba33fd2.png">: 小写符号用来表示一个向量，除非有其他的特指</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/94d9565abaadf04609a2e9941aa2d20b0a299b8a.png">: 向量<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/8136a7ef6a03334a7246df9097e5bcc31ba33fd2.png">的第i<br />
 个元素</li></ul>
<p><strong>符号和函数的列表</strong></p>
<ul><li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/9ffb448918db29f2a72f8f87f421b3b3cad18f95.png">: 输入的维度数.</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/5fa630dae8db4bf9cfd80b587bd337458409d6f7.png">: 第i 层隐藏单元的个数.</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/fa8e7a1fd21bcacff63ee44e2e78af72214fe54e.png">,&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/c96dd6ec1dc4ad7520fbdc78fcdbec9edd068d0c.png">:<br />
 和模型&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/add5793183306da7b16409b5d3505018d88531b8.png">相关的分类函数, 定义成&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/9109179093ef481255ce2f3f8d2ce1e81e58d8c4.png">.<br />
 注意到这里通常将下标&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/52e8ed7a3ba22130ad3984eb2cd413406475a689.png">丢弃掉.</li>
<li>L:标签的个数.</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/570041485c60e3ca67015b207993deb70725d1bb.png">: 由参数<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/52e8ed7a3ba22130ad3984eb2cd413406475a689.png">定义模型&nbsp;的<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/96d02faf3df447274e236cb6f2d22d6eeed8bac4.png">的log&#20284;然&nbsp;.</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/d5892c7f58882251d76b81e7561c57c80b665b70.png">&nbsp;在数据集<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/96d02faf3df447274e236cb6f2d22d6eeed8bac4.png">上由参数<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/52e8ed7a3ba22130ad3984eb2cd413406475a689.png">决定的预测函数<br />
 f 的期望损失.</li>
<li>NLL: 负&#20284;然log（negative log-likelihood，NLL）</li>
<li><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/52e8ed7a3ba22130ad3984eb2cd413406475a689.png">: 对于一个给定模型的所有参数集合</li></ul>
<p><strong>python的命名空间<br /><br />
</strong>本教程的代码通常使用下面的命名空间：</p>
<pre class="prettyprint linenums">import theano<br />
import theano.tensor as T<br />
import numpy</pre>
<p><strong>四、在DL上的有监督优化的入门<br /><br />
</strong></p>
<div>&nbsp; &nbsp;&nbsp;深度学习最让人兴奋的主要是利用深网络的无监督学习。不过有监督学习同样也扮演着很重要的角色。无监督预训练的使用通常是基于当使用有监督微调之后获得效果的基础上来进行评估的。本部分回顾下作为分类模型的有监督的基础部分，然后介绍下作为在许多dl教程中模型上使用的微调的minibatch随机梯度下降算法。详细的可以看看<a href="http://www.iro.umontreal.ca/~pift6266/H10/notes/gradient.html" rel="external nofollow noreferrer">introductory<br />
 course notes on gradient-based learning</a>&nbsp;，来了解更多关于使用梯度来优化训练标准的基本概念。</div>
<div>
<p><strong>学习一个分类器</strong></p>
<p><strong>zero-one 损失</strong></p>
<p>本教程中呈现的模型大多是用来做分类的。训练一个分类器的目标是为了最小化在不可见样本上的误差（0-1损失）的数量。如果&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/de7bf92ea2c5f063d00c4dbca0f5d91c7ab988da.png">是预测函数，那么损失函数可以写成：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ec8b5b509993eaca2019844f27bfbb8c5bd60bf5.png"></p>
<p>这里是<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/36eee9eaded3a8c323d85046041a94a032ded392.png">&nbsp;表示的是训练集合（在训练的时候）或者&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/1a1f3c1d3141f0d96f1147c6c6cfdaae8787909f.png">（为了避免验证集或者测试误差的有偏估计）。<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/027f4a11d6090f9eac0ce2488df6384dad1263ea.png">&nbsp;是指示函数，可以被定义成：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/dec195a9a34fc973305be999a966d74e01a76bef.png"><img referrerpolicy="no-referrer"src="/users/a42ei43jv/appdata/roaming/360se6/User Data/temp/dec195a9a34fc973305be999a966d74e01a76bef.png"></p>
<p>在这个教程中，f 被定义成：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/b68d62b38037cd2b95df9674d366df472c8236aa.png"></p>
<p>在python中，使用Theano的话，可以写成如下形式：</p>
<pre class="prettyprint linenums"># zero_one_loss is a Theano variable representing a symbolic<br />
# expression of the zero one loss ; to get the actual value this<br />
# symbolic expression has to be compiled into a Theano function (see<br />
# the Theano tutorial for more details)<br />
zero_one_loss = T.sum(T.neq(T.argmax(p_y_given_x), y))</pre>
<p><strong>负log&#20284;然损失</strong></p>
<p>因为0-1损失不能微分，对于大型模型（成千上百万的参数）的优化来说，代价是非常高昂的（计算量）。所以我们在训练集给定所有的标签的基础上让我们的分类器的log&#20284;然最大化：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/3b13c15532a8ff0ba031293290662d88a07070a6.png"></p>
<p>正确类别的&#20284;然和正确预测的数量是不相同的，不过从一个随机初始化的分类器的观点上看，它们相当接近。不过提醒下，0-1损失和&#20284;然是不同的目标；你需要看见它们是在验证集上是正相关的，不过有时候却是负相关的。因为我们通常说要最小化一个损失函数，所以学习其实就是为了最小化这个负log&#20284;然函数，定义为：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/06bb48f8f4aedccebf735114a7bbcc0d34039f77.png"></p>
<p>我们分类器的NLL是可微分的，所以可以用来代替0-1损失，而且我们在基于训练数据上使用这个函数的梯度作为<br />
 一个分类器的dl 有监督学习信号（其实就是用梯度来训练分类器的意思，我直译的而已）。这可以通过使用下面的代码来计算得到：</p>
<pre class="prettyprint linenums"># NLL is a symbolic variable ; to get the actual value of NLL, this symbolic<br />
# expression has to be compiled into a Theano function (see the Theano<br />
# tutorial for more details)<br />
NLL = -T.sum(T.log(p_y_given_x)[T.arange(y.shape[0]), y])<br />
# note on syntax: T.arange(y.shape[0]) is a vector of integers [0,1,2,...,len(y)].<br />
# Indexing a matrix M by the two vectors [0,1,...,K], [a,b,...,k] returns the<br />
# elements M[0,a], M[1,b], ..., M[K,k] as a vector.  Here, we use this<br />
# syntax to retrieve the log-probability of the correct labels, y.</pre>
<p><strong>随机梯度下降</strong></p>
<p>普通的梯度下降是什么？它是一个简单的算法，在这个算法中首先有由一些参数定义的损失函数表示的错误表面，然后在这个表面上重复的使用很小的步长进行下降的算法。针对于普通的梯度下降法的目的来说，训练数据是需要放入到这个损失函数中的。然后这个算法的伪代码可以写成如下形式：</p>
<pre class="prettyprint linenums"># GRADIENT DESCENT

while True:<br />
    loss = f(params)<br />
    d_loss_wrt_params = ... # compute gradient<br />
    params -= learning_rate * d_loss_wrt_params<br />
    if &lt;stopping condition is met&gt;:<br />
        return params</pre>
<p>随机梯度下降法是和用普通梯度下降法一样的原则来work的，不过可以通过每次一点样本来计算梯度从而更快速的进行处理，所以不需要一次放入整个训练样本了。对应的伪代码如下：</p>
<pre class="prettyprint linenums"># STOCHASTIC GRADIENT DESCENT<br />
for (x_i,y_i) in training_set:<br />
                            # imagine an infinite generator<br />
                            # that may repeat examples (if there is only a finite training set)<br />
    loss = f(params, x_i, y_i)<br />
    d_loss_wrt_params = ... # compute gradient<br />
    params -= learning_rate * d_loss_wrt_params<br />
    if &lt;stopping condition is met&gt;:<br />
        return params</pre>
<p>在dl 上我们推荐使用在随机梯度上的进一步变体，叫做“minibatches”。minibatch sgd的工作规则是和sgd一样的，只是我们在每次的梯度估计上使用不止一个训练样本来训练。这个技术可以梯度估计中间的方差，而且通常在现代计算机中可以更好地利用层级存储的组织方式：</p>
<pre class="prettyprint linenums">for (x_batch,y_batch) in train_batches:<br />
                            # imagine an infinite generator<br />
                            # that may repeat examples<br />
    loss = f(params, x_batch, y_batch)<br />
    d_loss_wrt_params = ... # compute gradient using theano<br />
    params -= learning_rate * d_loss_wrt_params<br />
    if &lt;stopping condition is met&gt;:<br />
        return params</pre>
<p>这是在minibatch size<br />
&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ff5fb3d775862e2123b007eb4373ff6cc1a34d4e.png">的选择上的权衡考虑。方差的减小和SIMD指令的使用在当<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ff5fb3d775862e2123b007eb4373ff6cc1a34d4e.png">从1增加到2的时候通常是很有帮助的，不过这个很小的提升却会很快的回归虚无。使用更大的<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ff5fb3d775862e2123b007eb4373ff6cc1a34d4e.png">，时间会消耗在减少梯度估计器的方差减少上，本来这些时间是应该更好的用在额外的梯度步长上的。一个最优的<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ff5fb3d775862e2123b007eb4373ff6cc1a34d4e.png">是基于模型、数据集、和硬件考虑的，同时可以在任何地方从1上升到甚至好几百。在这个教程中，我们将它设置成20，不过这个选择通常是任意的。<br /><br />
note：如果你训练的时候使用的是固定数量的epochs，那么这个minibatch size就变得很重要了，因为它控制着你的参数的更新次数。使用batch size 为1 的10次epochs来训练相同的模型得到的结果完全不同于训练batch size 为20的而且也是10个epochs的结果。记得，在不同的batch sizes之间转换的时候，记得按照使用过的这个batch size 来调整所有的其他参数。</p>
<p>上面所有的演示该算法的伪代码块，在theano中执行同样的算法的代码如下：</p>
<pre class="prettyprint linenums"># Minibatch Stochastic Gradient Descent

# assume loss is a symbolic description of the loss function given<br />
# the symbolic variables params (shared variable), x_batch, y_batch;

# compute gradient of loss with respect to params<br />
d_loss_wrt_params = T.grad(loss, params)

# compile the MSGD step into a theano function<br />
updates = [(params, params - learning_rate * d_loss_wrt_params)]<br />
MSGD = theano.function([x_batch,y_batch], loss, updates=updates)

for (x_batch, y_batch) in train_batches:<br />
    # here x_batch and y_batch are elements of train_batches and<br />
    # therefore numpy arrays; function MSGD also updates the params<br />
    print(&#039;Current loss is &#039;, MSGD(x_batch, y_batch))<br />
    if stopping_condition_is_met:<br />
        return params</pre>
<p><strong>正则化</strong></p>
<p>除了优化，在机器学习中还有更重要的部分。当我们从数据中训练我们的模型的时候，我们是将它准备用在新样本上的，而不是那些我们已经见过的样本。上面的MSGD的训练循环如果没有考虑到这一点，也许就会过拟合训练样本。一个对应过你的方法就是正则化。这里有好几种正则化的方法，这里会介绍L1/L2正则化和早期停止。</p>
<p><strong>L1/L2 正则化<br /><br />
</strong>&nbsp; &nbsp; L2和L2正则化涉及到在损失函数上增加额外的项，用来惩罚某一个参数组合。形式上，如果我们的损失函数是：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/06bb48f8f4aedccebf735114a7bbcc0d34039f77.png"></p>
<p>那么正则化损失就该是：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/fce8351623b211dfbe817a1474c9b2f798045698.png"></p>
<p>或者，在我们的情况中：</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/d298afb310754d8f4949b2cd83ff5bd2297c122b.png"></p>
<p>这里</p>
<p><img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/959833a91dd4b88e15c23428f543311bc4b7f74e.png"></p>
<p>这是&nbsp;<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/52e8ed7a3ba22130ad3984eb2cd413406475a689.png">的<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/d855c6a7ae519f92171373ddc597246ab1abfe77.png">&nbsp;范数。<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ce4588fd900d02afcbd260bc07f54cce49a7dc4a.png">是一个超参数，用来控制正则化参数的相关重要性。通常<br />
 p的&#20540;是1和2，所以命名为L1/L2，如果p=2，那么这个正则化叫做“权重衰减”。原则上说，对损失函数增加一个正则化项将会使得在NN中网络更加的平滑（通过惩罚&#20540;较大的参数，这些&#20540;较大的参数会降低网络模型的非线性程度，所以需要惩罚）。更直观的说，这两项（NLL和<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/5f74b7b36cc295349c0c4e19b1dc7993d3419d45.png">）对应于很好的对数据进行建模（NLL）和有着“简单”或“平滑”的解决方法<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/5f74b7b36cc295349c0c4e19b1dc7993d3419d45.png">。因此，最小化这两个项的和，从理论上来说，就是为了在拟合训练数据和解决方法的“泛化”之间找到正确的平衡点。为了遵循Occam的razor原则，这个最小化应该让我们找到最简单的解决方法（通过我们简单的标准来测量的）来拟合训练数据。注意到这样一个事实，一个所谓的“简单”的解决方法不是意味着能够很好的泛化。经验上来说，通常是在NN的背景下这样的正则化的添加有助于泛化，特别是对于小的数据集来说。下面的代码块用来表示当包含由<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/72519e3a9009a9367ff40876072dda5c24c4dfdf.png">来权重化的L1正则化项和由<img referrerpolicy="no-referrer"src="http://deeplearning.net/tutorial/_images/math/ee145dd82bf7803729dba9ca823eae73a80d6698.png">来权重化的L2正则化项的时候如何在python中计算损失的：</p>
<pre class="prettyprint linenums"># symbolic Theano variable that represents the L1 regularization term<br />
L1  = T.sum(abs(param))

# symbolic Theano variable that represents the squared L2 term<br />
L2_sqr = T.sum(param ** 2)

# the loss<br />
loss = NLL + lambda_1 * L1 + lambda_2 * L2</pre>
<p><strong>早期停止</strong></p>
<p>用早期停止来解决过拟合是通过在验证集合上监测模型的执行结果来完成的。验证集就是我们在梯度下降的时候未使用的样本集，不过这同样也不是测试集的一部分。验证集样本是被认为作为未来测试集样本的代表的。我们可以在训练的时候使用时因为它们不是测试集的一部分。如果模型的效果在验证集上已经停止了提升，或者甚至在后面的优化上还有下降，那么这里需要做的就是停止使用更多的优化。选择什么时候停止是一个主观判断而且是存在启发式的，不过这些教程将会在基于会具有几何增长的patience数量上使用一些策略：</p>
<pre class="prettyprint linenums"># early-stopping parameters<br />
patience = 5000  # look as this many examples regardless<br />
patience_increase = 2     # wait this much longer when a new best is<br />
                              # found<br />
improvement_threshold = 0.995  # a relative improvement of this much is<br />
                               # considered significant<br />
validation_frequency = min(n_train_batches, patience/2)<br />
                              # go through this many<br />
                              # minibatches before checking the network<br />
                              # on the validation set; in this case we<br />
                              # check every epoch

best_params = None<br />
best_validation_loss = numpy.inf<br />
test_score = 0.<br />
start_time = time.clock()

done_looping = False<br />
epoch = 0<br />
while (epoch &lt; n_epochs) and (not done_looping):<br />
    # Report &quot;1&quot; for first epoch, &quot;n_epochs&quot; for last epoch<br />
    epoch = epoch + 1<br />
    for minibatch_index in xrange(n_train_batches):

        d_loss_wrt_params = ... # compute gradient<br />
        params -= learning_rate * d_loss_wrt_params # gradient descent

        # iteration number. We want it to start at 0.<br />
        iter = (epoch - 1) * n_train_batches + minibatch_index<br />
        # note that if we do `iter % validation_frequency` it will be<br />
        # true for iter = 0 which we do not want. We want it true for<br />
        # iter = validation_frequency - 1.<br />
        if (iter + 1) % validation_frequency == 0:

            this_validation_loss = ... # compute zero-one loss on validation set

            if this_validation_loss &lt; best_validation_loss:

                # improve patience if loss improvement is good enough<br />
                if this_validation_loss &lt; best_validation_loss * improvement_threshold:

                    patience = max(patience, iter * patience_increase)<br />
                best_params = copy.deepcopy(params)<br />
                best_validation_loss = this_validation_loss

        if patience &lt;= iter:<br />
            done_looping = True<br />
            break

# POSTCONDITION:<br />
# best_params refers to the best out-of-sample parameters observed during the optimization</pre>
<p>如果我们在跑完patience之前跑完了所有的训练数据，那么我们只需要回到训练数据的开始部分，然后再来一次。</p>
<p>note：validation_frequency应该总是要小于patience的。在跑完patience之前代码需要检查至少两次。这是因为我们使用的公式validation_frequency<br />
 = min( value,patience/2)。</p>
<p>note：当决定什么时候需要增大patience的时候，算法可以通过使用统计测试的方法来明显的提升，而不是简单的使用对比。</p>
<p><strong>测试</strong></p>
<p>在现有的循环之后，best_params变量表示在验证集上best-performing的模型。如果我们给另一个模型类别重复这个过程，或者甚至使用另一个随机初始化，我们应该也要对数据使用相同的train/valid/test划分，然后得到其他best-performing模型。如果我们不得不需要选择最好的模型类别或者最好的初始化，我们需要对每个模型进行对比best_validation_loss。当我们选择我们认为的最好的模型（基于验证集）的时候，我们会将这个模型用在测试集上，并报告结果。</p>
<p><strong>回顾</strong></p>
<p>这是为了优化部分准备的。早期停止的技术需要我们将样本集合划分成三个不同的集合（训练集、验证集、测试集）。训练集用来作为目标函数的可微分的近&#20284;函数的minibatch<br />
 sgd上。当我们执行梯度下降的时候，我们定期的使用验证集来观察我们在真正的目标函数上模型的结果（或者至少从经验上分析）。当我们在验证集上看到一个好的模型的时候，我们需要保存下来，当我们发现从看到一个好模型已经过去了很久，那么我们就放弃我们的研究，回头去找到那些最好的参数，然后在测试集上进行评估。</p>
<p><strong>五、theano/python的提示</strong></p>
<p><strong>装载和保存模型</strong></p>
<p>当你做实验的时候，会花费好几个小时（或者几天）来做梯度下降然后找到最好的参数。一旦你找到了它们，你将会需要保存这些权重。随着研究的开展，你也许同样会想要保存你当前最好的结果。</p>
<p><strong>从共享变量中pickle这个numpy ndarrays</strong></p>
<p>最好的保存/存档你的模型的参数的方法是使用pickle或者深度复制ndarray对象。例如，如果你的参数都放在共享变量w，v，u中，那么你可以像下面的命令来保存：</p>
<pre class="prettyprint linenums">&gt;&gt;&gt; import cPickle<br />
&gt;&gt;&gt; save_file = open(&#039;path&#039;, &#039;wb&#039;)  # this will overwrite current contents<br />
&gt;&gt;&gt; cPickle.dump(w.get_value(borrow=True), save_file, -1)  # the -1 is for HIGHEST_PROTOCOL<br />
&gt;&gt;&gt; cPickle.dump(v.get_value(borrow=True), save_file, -1)  # .. and it triggers much more efficient<br />
&gt;&gt;&gt; cPickle.dump(u.get_value(borrow=True), save_file, -1)  # .. storage than numpy&#039;s default<br />
&gt;&gt;&gt; save_file.close()</pre>
<p>然后，你可以像这样装载你的数据：</p>
<pre class="prettyprint linenums">&gt;&gt;&gt; save_file = open(&#039;path&#039;)<br />
&gt;&gt;&gt; w.set_value(cPickle.load(save_file), borrow=True)<br />
&gt;&gt;&gt; v.set_value(cPickle.load(save_file), borrow=True)<br />
&gt;&gt;&gt; u.set_value(cPickle.load(save_file), borrow=True)</pre>
<p>这些技术是有一点过于详尽了，不过试过都是正确的。你可以在matplotlib中毫无问题的装载你的数据然后对它进行加工。</p>
<p><strong>不要为需要长期存储的目的而pickle你的训练或测试函数</strong></p>
<p>theano函数是兼容python的深度复制和pickle机制的，不过你没必要一定pickle一个theano函数。如果你更新你的theano文件夹或者说其内部有一些改变，那么你也许没法unpickle你的模型。theano仍然是一个动态的开发项目，内部的APIs可能会改变。所以从安全角度上来说，不要为了长期的存储而pickle你的整个训练或者测试函数（也就是如果save几天或者几个&#31036;拜估计还ok，就是怕几个月之后更新了theano，之前的保存的就没法读取了）。pickle机智是为了短期存储而准备的，例如一个临时文件，或者在一个分布式工作中从一个机器上复制到另一个机器上。</p>
<p>了解更多可以看看&nbsp;<a href="http://deeplearning.net/software/theano/tutorial/loading_and_saving.html" rel="external nofollow noreferrer">serialization<br />
 in Theano</a>, 或者 Python的&nbsp;<a href="http://docs.python.org/library/pickle.html" rel="external nofollow noreferrer">pickling</a>.</p>
<p><strong>显示中间的结果</strong></p>
<p>可视化对于理解你的模型或者训练算法在干什么是很有帮助的工具。你可能需要视图键入matplotlib画图命令，或者PIL 图像呈现命令到你的模型训练脚本中。然而，之后你可能想要从这些预呈现的图形中显示一些你感兴趣的或者想要看看从图形中得到的是否清晰，那么你需要保存原始的模型。</p>
<p><strong>如果你有足够的磁盘空间，你的训练脚本应该保存中间模型并且一个可视化脚本应该用来处理这些保存的模型。</strong></p>
<p>你已经有了一个模型保存函数了吗？可以再次使用它来保存这些中间模型</p>
<p>你可能会想要了解的库：python图像库&nbsp;(<a href="http://www.pythonware.com/products/pil" rel="external nofollow noreferrer">PIL</a>),&nbsp;<a href="http://matplotlib.sourceforge.net/" rel="external nofollow noreferrer">matplotlib</a>.</p>
<p><strong>参考资料：</strong></p>
<p>[1]<br />
 官网：http://deeplearning.net/tutorial/gettingstarted.html#gettingstarted</p>
<p>[2]&nbsp;theano学习指南1：http://www.cnblogs.com/xueliangliu/archive/2013/04/03/2997437.html</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnjgp28.html">APP开发  Token生成 验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jvvrl9.html">Java学习日记之 Java-IO流</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv77jjq.html">&lbrack;PHP&rsqb;Yii2框架的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvnl2x9.html">Axure7&period;0汉化方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/390gwd48.html">【转载】debian上快速搭建ftp</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4xrge8.html">Android view 的事件分发机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmw4vz9.html">【KMP】Period</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnrj79.html">&lbrack;LeetCode&rsqb;题解（python）：142-Linked List Cycle II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxklm2d8.html">Python基础学习6---存储器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96plnwj8.html">关于极光推送Jpush的demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjpkzl8.html">mysql与emoji和特殊字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzy34g8.html">Spring boot 源码分析（一）SpringApplication&period;run&lpar;上&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3xel9.html">oracle 触发器详情</a>
		</li>
						<li><a href="https://www.batexi.com/a/q250gwoq.html">分布式通讯架构RPC简单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1orweq.html">pandas设置值、更改值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jllo3q.html">python3中最新百度首页弹窗的登录方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve5jw19.html">go语言之行--简介与环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7enpo19.html">实验七 c字符数组和字符串函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnyjekq.html">Dependency Injection in ASP&period;NET Web API 2 Using Unity</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp6yk49.html">怎么用MathType输入对数函数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rqlxkvxq.html">dpkg</a>
			</li>
						<li><a href="https://www.batexi.com/a/3901ke38.html">html5 datalist自动完成</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rww6eq.html">HDU 5895 Mathematician QSC&lpar;矩阵乘法&plus;循环节降幂&plus;除法取模小技巧&plus;快速幂&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlx77kq.html">java分层开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/r936lxw9.html">配置WebSite的IIS时遇到的问题与解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ex6zmq.html">html实现弹框，并伴随遮罩层，且弹框居中</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7j14xq.html">nginx应用总结（2）--突破高并发的性能优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7mk1q.html">js 增删改查方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gxvk0q.html">IntelliJ IDEA 编译maven项目以及运行测试前编译项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlx36xq.html">Hibernate总结1（入门）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
